proc do-help {} {
show-status "Opening Help Window ..." main-status
    catch {destroy .help}
    toplevel .help
    wm title .help "TkfPW Help"
    wm geometry .help 70x40
    wm minsize .help 1 1

    pack [frame .help.f -background black] \
            -expand y -fill both
    pack [scrollbar .help.f.scr -command {.help.f.f.text yview}] \
            -side left -fill y -padx 1
    pack [frame .help.f.f ] \
            -expand y -fill both
    pack [text .help.f.f.text -wrap word -setgrid true \
            -width 55 -yscroll {.help.f.scr set} ] \
            -side left -expand y -fill both -padx 5
    pack [button .help.done -text done -command {destroy .help}] \
            -side bottom -fill x

    put-text .help.f.f.text {

<hdr>TkfPW</hdr>

  This tool is intended to be a graphical front-end to the management of Fortran Projects. This tool keeps the spirit and remains nearly compatible with the older <itl>fPW</itl> shell scripts.

  You need Tcl/Tk installed on your system and an sh-compatible command language interpreter. Concerning Tcl/Tk, TkfPW runs with version <itl>Tcl/Tk 8.0.</itl> that you can retrieve at the following URL :

      <itl>http://www.sunlabs.com/research/tcl/</itl>

<hdr>TkfPW Web Sites</hdr>

 URL:	<cmp>http://www.ec-nantes.fr/DMN/WWW/Software/TkfPW</cmp>
	<itl>http://SAL.KachinaTech.COM/F/2/TKFPW.html</itl>
 ftp:	<itl>ftp://ftp.ec-nantes.fr/pub/DMN/TkfPW</itl>

<hdr>Version</hdr>

  This is Release 1.3 (lun, 14. dc  1998 12:40:05) of <itl>TkfPW</itl>.


<hdr>Platform</hdr>

  <itl>TkfPW</itl> has been probed on SGI machines running IRIX 5.2, 6.2 & 6.4 and on Intel Pentium PC running Linux but should run on any computer running Unix and Tcl/Tk (see before for desired version).


<hdr>Startup</hdr>

  <itl>TkfPW</itl> needs to know the location of the distribution as an environment variable : <cmp>TKFPW_HOME</cmp>. A good choice is <cmp>/usr/local/lib/TkfPW</cmp>.

  <itl>TkfPW</itl> is simply started as :<cmp>

    	tkfpw &</cmp>

  If the ressource file <cmp>.tkfpwrc</cmp> doesn't exist at startup, <itl>TkfPW</itl> will create it from the standard distribution.


<hdr>Customizing</hdr>

  Customizing <itl>TkfPW</itl> is possible with the <btn>Configure</btn> button in the main window. The choosen options are then saved in the <cmp>.tkfpwrc</cmp> Home file.

  The <itl>TkfPW</itl> defaults X ressources are taken from the <cmp>$TKFPW_HOME/XTkfPW</cmp> file. Customization consists in adding then modifying the <cmp>$TKFPW_HOME/XTkfPW</cmp> entries into your ~/.Xdefaults ressource file.

  As an example, if you prefer a red color (!) for the Frame BackGround, you could add this entry to your .Xdefaults file :
<cmp>
! ================================
! TkfPW Standard Widgets : Frame
! ================================

tkfpw*Frame.background: red
</cmp>

  If you are working on a B/W X terminal, you can try the following color set :
<cmp>
! ================================
! TkfPW Grey color set
! ================================
tkfpw*activeBackground: white
tkfpw*activeForeground: black
tkfpw*selectColor: black
tkfpw*background: #efefef
tkfpw*foreground: black
tkfpw*selectBackground: grey66
tkfpw*Button.highlightBackground: #7f7f7f
tkfpw*troughColor: #efefef
tkfpw*Scrollbar.background: #dfdfdf
tkfpw*Scale.background: #dfdfdf
tkfpw*disabledforeground: #7f7f7f
tkfpw*Listbox.highlightBackground: #7f7f7f
tkfpw*Listbox.selectBackground: black
</cmp>


<hdr>ToDo</hdr>

  I apologize for the English syntax errors. Feel free to send me your comments about it.


<hdr>Credits</hdr>

  Thanks go to Brent Welch (<itl>welch@parc.xerox.com</itl>) for his book "Practical Programming in Tcl and Tk", available at :

	ftp://mercury.prenhall.com/pub/software/welch/tkbook.tar

  Additional credit goes to John Klassa (<itl>klassa@aur.alcatel.com</itl>), author of <itl>TkDiff</itl>, a great Tk-based graphical front-end to the standard Unix <itl>diff</itl> utility. I shamelessly stole his tags routines and used them here for this Help Window. A last thanks to Anthony Thyssen (<itl>anthony@cit.gu.edu.au</itl>) for the icones from the <itl>Anthony's Icon Library</itl> at <itl>http://www.cit.gu.edu.au/~anthony/icones/</itl>

  Countless others have offered their suggestions and encouragement, specially Michel Visonneau (<itl>Michel.Visonneau@ec-nantes.fr</itl>) and Emmanuel Guilmineau (<itl>Emmanuel.Guilmineau@ec-nantes.fr</itl>) during the probation phases and other environment choices (you should bless them if you like the colors !). I thank you one and all !


<hdr>Comments</hdr>

  Questions, comments and improvements should be sent to Patrick Queutey at <itl>Patrick.Queutey@ec-nantes.fr</itl>.


    }

    .help.f.f.text configure -state disabled

}

proc put-text {tw txt} {

    $tw configure -font -*-Times-Medium-R-Normal-*-140-*

    $tw tag configure bld -font -*-Times-Bold-R-Normal-*-140-*
    $tw tag configure cmp -font -*-Courier-Bold-R-Normal-*-120-*
    $tw tag configure hdr -font -*-Times-Bold-R-Normal-*-180-* -underline 1
    $tw tag configure itl -font -*-Times-Medium-I-Normal-*-140-*
    $tw tag configure rev -foreground white -background black

    $tw tag configure btn \
            -font -*-Courier-Medium-R-Normal-*-120-* \
            -foreground black -background white \
            -relief groove -borderwidth 2

    $tw mark set insert 0.0

    set t $txt

    while {[regexp -indices {<([^@>]*)>} $t match inds] == 1} {

        set start [lindex $inds 0]
        set end [lindex $inds 1]
        set keyword [string range $t $start $end]

        set oldend [$tw index end]

        $tw insert end [string range $t 0 [expr $start - 2]]

#        purge-all-tags $tw $oldend insert

        if {[string range $keyword 0 0] == "/"} {
            set keyword [string trimleft $keyword "/"]
            if {[info exists tags($keyword)] == 0} {
                error "end tag $keyword without beginning"
            }
            $tw tag add $keyword $tags($keyword) insert
            unset tags($keyword)
        } else {
            if {[info exists tags($keyword)] == 1} {
                error "nesting of begin tag $keyword"
            }
            set tags($keyword) [$tw index insert]
        }

        set t [string range $t [expr $end + 2] end]
    }

    set oldend [$tw index end]
    $tw insert end $t
#    purge-all-tags $tw $oldend insert
}

proc purge-all-tags {w start end} {
    foreach tag [$w tag names $start] {
        $w tag remove $tag $start $end
    }
}
